%define name	kaffe
%define version	1.0.6
%define release	11mdk
%define cvsdate	20010819

Summary:	A free virtual machine for running Java(TM) code
Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		2
License:	GPL
Url:		http://www.kaffe.org/
Group:		Development/Java

Source0:	ftp://ftp.transvirtual.com/pub/kaffe/kaffe-snap-%{cvsdate}.tar.bz2
Patch0:		kaffe-alpha.patch.bz2
Patch2:		kaffe-1.0.6-perlpath.patch.bz2
Patch3:		kaffe-1.0.6.mdk.patch.bz2
Patch4:		kaffe-1.0.6.mdk.keypad.patch.bz2
Patch5:		kaffe-1.0.6.mdk.font.patch.bz2
Patch6:		kaffe-1.0.6.mdk.focus.patch.bz2
Patch11:	kaffe-getBytes.patch.bz2
Patch12:	kaffe-sparc.patch.bz2
Patch15:	kaffe-1.0.6.mdk.glibc22.patch.bz2
Patch16:	kaffe-1.0.6-ia64.patch.bz2
Patch17:	kaffe-1.0.6-includes.patch.bz2

Obsoletes:	kaffe-bissawt
BuildRequires:	gmp-devel libjpeg-devel libpng-devel XFree86-devel
BuildRequires:	zip zlib-devel
%ifarch ia64
Requires:	x86-kaffe = %{version}-%{release}
BuildRequires:	gcc3.0
%endif
BuildRoot:	%{_tmppath}/%{name}-%version-root
BuildConflicts:	jikes

%description
Kaffe is a free virtual machine designed to execute Java(TM) bytecode.
Kaffe can be configured in two modes.  In the first mode, it operates
as a pure bytecode interpreter (not unlike Javasoft's machine).  In
the second mode, it performs "Just-In-Time" code conversion from the
abstract code to the host machine's native code.  The second mode will
ultimately allow execution of Java code at the same speed as standard
compiled code, while also maintaining the advantages and flexibility
of code independence.

Install the kaffe package if you need a Java virtual machine.

%package devel
Summary: Development package with static libs and headers for kaffe.
Group: Development/C
Requires: %{name} = %{version}

%description devel
This package contains the static libraries, header files and documentation
necessary for development of programs that will use kaffe.

You should install this package if you need to develop programs which
will use kaffe functions.
You'll also need to install kaffe package.

%ifarch %{ix86}
%package -n x86-kaffe
Summary: Kaffe JVM binaries and libraries only
Group:   Development/Java

%description -n x86-kaffe
This package contains only the Kaffe binaries and libraries built on
ia32 but intended to run on ia64. The ia32 version of Kaffe can be
invoked but adding "-ia32" to the relevant Kaffe command line tools
(java, javac, ...)
%endif

%prep
%setup -q -n kaffe-snap
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch11 -p1
%patch12 -p1 -b .sparc
%patch15 -p2
%patch16 -p1 -b .ia64
%patch17 -p1 -b .includes

%build
KAFFE_OPT_FLAGS=$(echo $RPM_OPT_FLAGS|sed 's/-fomit-frame-pointer//g')
%ifarch %{ix86}
KAFFE_OPT_FLAGS="$KAFFE_OPT_FLAGS -O2"
%endif
CFLAGS="$KAFFE_OPT_FLAGS"

%ifarch ia64
export CC=gcc-$(gcc3-version)
%endif

%configure --disable-gcj \
	   --libdir=%{_libdir}/kaffe/%{_target_cpu} \
	   --libexecdir=%{_libdir}/kaffe/%{_target_cpu} \
	   --disable-rpath

find . -type 'd' -name "CVS" -print | xargs /bin/rm -rf

# hugly world <yves>
find . -name Makefile | xargs perl -pi -e 's,LIBS = *-L/usr/local/lib *-R/usr/local/lib,LIBS=,;'

%make all
%make Klasses

%install
rm -rf $RPM_BUILD_ROOT

#%makeinstall_std
make install DESTDIR=$RPM_BUILD_ROOT nativedir=%{_libdir}/kaffe/%{_target_cpu}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README FAQ license.terms
%{_mandir}/*/*
%{_bindir}/*
%{_libdir}/kaffe/%{_target_cpu}/Kaffe
%{_libdir}/kaffe/%{_target_cpu}/*.so
%{_datadir}/kaffe

%files devel
%defattr(-,root,root)
%doc README developers
%{_includedir}/kaffe
%{_libdir}/kaffe/%{_target_cpu}/*.la

%ifarch %{ix86}
%files -n x86-kaffe
%defattr(-,root,root)
%{_libdir}/kaffe/%{_target_cpu}/Kaffe
%{_libdir}/kaffe/%{_target_cpu}/*.so
%endif

%changelog
* Fri Dec  7 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0.6-11mdk
- Update to 2001/08/19 snapshot
- Use make DESTDIR=%%{buildroot} install
- Lower ia32 optimizations to -O2, gcc RTL inliner seems bogus with Kaffe
- Remove BuildRequires: libffi-devel for PPC since Kaffe now provides
  sysdepCallMethod() for that architecture
- Remove obsolete Patch13 & Patch14
- Patch17: Add missing includes
- Patch16: Rewrite IA-64 additions (still needs gcc3). Old Kaffe
  (ia32) can still be invoked by passing the "-ia32" command line
  option to the respective tools (java, javac, ...)

* Wed Dec  5 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0.6-10mdk
- change requires for PPC from libffi to libffi-devel

* Wed Oct 10 2001 Stefan van der Eijk <stefan@eijk.nu> 1.0.6-9mdk
- add BuildRequires

* Tue Jul 17 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0.6-8mdk
- spec file sanitizification (s/Serial/Epoch, s/Copyright/License)
- split %%make all Klasses

* Tue Feb 27 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 1.0.6-7mdk
- Fix build with new glibc (more strict headers)

* Thu Jan  4 2001 Yves Duret <yduret@mandrakesoft.com> 1.0.6-6mdk
- put back some lib in main package

* Wed Jan  3 2001 Yves Duret <yduret@mandrakesoft.com> 1.0.6-5mdk
- disable gcj support, since it breaks with gcc 2.96
- devel related stuff moved to -devel package
- clean up the spec file

* Fri Oct 27 2000 David BAUDENS <baudens@mandrakesoft.com> 1.0.6-4mdk
- Fix build on PPC

* Fri Oct 13 2000 Stefan van der Eijk <s.vandereijk@chello.nl> 1.0.6-3mdk
- made Buildroot standard
- remove configure.in in %%prep to make go with %%configure in pinstripe (RH)
- removed alpha patch (RH)
- added getBytes patch (RH)
- added sparc patch (RH)
- added jlong patch (otherwise won't compile on alpha) (RH)
- added gc-incremental patch (Kaffe ML)
- removed old commented stuff
- macro's (configure, make, makeinstall)
- let spec helper do it's job (compressing & stripping)

* Mon Sep 25 2000 Maurizio De Cecco <maurizio@mandrakesoft.com> 1.0.6-2mdk
- removed CVS junk

* Mon Aug 8 2000 Maurizio De Cecco <maurizio@mandrakesoft.com> 1.0.6-1mdk
- Moved to kaffe 1.0.6
- Remove those patches that have been incoporated with the official kaffe distribution
- fixed man/lib/bin path according to the FHS.

* Fri May 26 2000 David BAUDENS <baudens@mandrakesoft.com> 1.0.5-11mdk
- BuildConflicts: jikes
- Use %%{_tmppath} for BuildRoot

* Fri May  5 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 10mdk
- Removed jpeg patch added in 8mdk; the libjpeg/autoconf problem
  has been fixed in libjeg-14mdk

* Wed Apr 26 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 9mdk
- Fixed bug in AWT focus handling.

* Mon Apr 20 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 8mdk
- Patched to force jpeg support inclusion, to cope with a bug/incompatibility
  between libjpeg and autoconf.

* Mon Apr 17 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- 7mdk
- Fixed memory corruption problem in FontMetrics/XFontStruct.

* Thu Apr 13 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Really Added patch to fix kaffe behavoiur with the Keypad.

* Wed Apr 12 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Added patch to fix kaffe behavoiur with the Keypad.

* Tue Apr 11 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Fixed Distribution name

* Tue Mar 28 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Fixed a bug in key event handling.

* Tue Mar 14 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Added Mandrake Patches for Process, TextField and TextComponent classes
- Upgraded the kjc compiler to version 1.4C.
- Modified build process to rebuild the patched class library
- Adapted to the new group structure

* Tue Oct 26 1999 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Mandrake version for 1.05

* Mon Oct 18 1999 Bill Nottingham <notting@redhat.com>
- 1.0.5. Lets see what it does.

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- build for alpha (it seems to work...)
- fix paths so it works

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- according to the kaffe people, b4 is a "massive bugfix release"

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Thu Mar 18 1999 Bill Nottingham <notting@redhat.com>
- strip binaries

* Tue Dec 15 1998 Bill Nottingham <notting@redhat.com>
- add an Obsoletes: for kaffe-bissawt

* Wed Dec  9 1998 Bill Nottingham <notting@redhat.com>
- update to 1.0b3
- include alpha patch, but it's still broke

* Mon Oct 05 1998 Cristian Gafton <gafton@redhat.com>
- added sparc to the list of supported architectures
- update to 1.0b2

* Tue Sep 22 1998 Bill Nottingham <notting@redhat.com>
- don't rename libraries; install them in /usr/lib/kaffe
- remove sparc arch (doesn't work)

* Thu Jul 23 1998 Jeff Johnson <jbj@redhat.com>
- update to 1.0.b1.
- add sparc arch (alpha has problems kaffe/kaffeevm/support.c:{343,518}

* Fri May 08 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Mon May 04 1998 Cristian Gafton <gafton@redhat.com>
- finally their ftp site is up again: updated to 0.10.0
- too bad the Biss-AWT doesn't seem to be maintained anymore... Removed the
  bissawt package
- unfortunately alpha and sparc assembler code that reference registers
  like eax, ebx, etc. makes this package ExclusiveArch: i386

* Tue Dec 09 1997 Cristian Gafton <gafton@redhat.com>
- added kaffe to the file list
- added BuildRoot; cleaned the spec file

* Tue Nov 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- removed pieces with incompatible licenses

* Tue Oct 21 1997 Erik Troan <ewt@redhat.com>
- updated to 0.9.2

* Mon Aug 25 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Thu Apr 24 1997 Erik Troan <ewt@redhat.com>
- added libkaffe_vm.so symlink.

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- added manual provide of libkaffe_vm.so (RPM seems a bit broken).
